		AREA Text_Out, CODE, READONLY

SWI_ANGEL EQU 0x123456		;SWI number for Angel semihosting	

		MACRO
$l		Exit					;Angel SWI call to terminate execution
$l		MOV		r0, #0x18		;select Angel SWIreason_ReportException(0x18)
		LDR     r1, =0x20026	;report ADP_Stopped_ApplicationExit
		SWI 	SWI_ANGEL		;ARM semihosting SWI
		MEND

		MACRO
$l		WriteC					;Angel SWI call to output character in [r1]
$l		MOV		r0, #0x3		;select Angel SYS_WRITEC function
		SWI		SWI_ANGEL
		MEND



		ENTRY			;code entry point
		BL		TextOut		;print following string
		=		"Test string", &0a, &0d, 0
		ALIGN
		Exit	;finish


TextOut	;output string starting at [r14]
		MOV		r0, #0x3		;select Angel SYS_WRITEC function
NxtTxt	LDRB	r1, [r14], #1	;get next character
		CMP		r1, #0			;test for end mark
		SUBNE	r1, r14, #1		;setup r1 for call to SWI
		SWINE	SWI_ANGEL		;if not end, print..
		BNE		NxtTxt			; ..and loop
		ADD		r14, r14, #3	;pass next word boundary
		BIC		r14, r14, #3	;round back to boundary
		MOV		pc, r14			;return
		END