		AREA	Timer, CODE, READWRITE
		EXPORT	INTBASE
		EXPORT	TIMERBASE
		EXPORT	INITTIMER

INTBASE	  EQU 0x0a000000
TIMERBASE EQU 0x0a800000

INITTIMER
		;initialise interrupt controller
		LDR		r0, =INTBASE
		MOV		r1, #0x10
		STR		r1, [r0,#0x8]	

		;initialise timer
		LDR		r0, =TIMERBASE
		LDR		r1, TIMECNT
		STR		r1, [r0]
		MOV		r1, #0xC0;		;enable timer, periodic mode
		STR		r1, [r0,#0x8]
		LDR		r0, =TIMERBASE
		STR		r0, [r0,#0xc]
		
		;return
		MOV		pc, lr
		
		
TIMECNT	DCD 0xff				;timer initial value

		END		