		AREA	Prot_unit,CODE,READWRITE
		EXPORT	INITPROT
		;program protection unit through CP15
INITPROT
		MOV		r1, #0x3f				;region 0 (other code) ->set to all of memory
		MCR		p15, 0, r1, c6, c0, 0	;set up region 0
		MOV		r1, #0x10000			;region 1 (user code) ->set base address 
		BIC		r1, r1, #0xff
		ORR		r1, r1, #0x17			;region 1 (user code) ->set size to 4kb and enable region
		MCR		p15, 0, r1, c6, c1, 0	;set up region 1
		MOV		r1, #0xd				;
		MCR		p15, 0, r1, c5, c0, 0	;set up protection register
		MOV		r1, #1
		MCR		p15, 0, r1, c1, c0, 0	;enable protection
		MOV		pc, lr

		END
